<?php
/*
Plugin Name: WP-ExpandURL
Plugin URI: http://wazong.de/blog/tag/wordpress/
Description: This plugin expands shortened URLs in Posts
Author: Thomas Renger
Version: 0.1
Author URI: http://wazong.de/blog/

Changes:

20090818 - 0.1: initial relase

*/

function wpeu_find_destination($url) {
  $remoteheaders = get_headers($url,1);
  $realLocation =$remoteheaders['Location'];
  if(strlen($realLocation)>0) {
  return $realLocation;
  } else {
  return $url;
  }
}

function wpeu_canonify_urls($ret) {
   
   $links = explode('<a', $ret);
   $countlinks = count($links);
   for ($i = 0; $i < $countlinks; $i++) {
      $link = $links[$i];

      $link = (preg_match("#(.*)(href=\\\")#is", $link)) ? '<a' . $link : $link;
      $match = strpos($link, "href=\\\"");
      if($match === false ) {
	      continue;
      }
      $begin = $match + 7;
      $end = strpos($link, "\\\"", $begin);
      $length = $end - $begin;
      $urlname = substr($link, $begin, $length);

      $real=wpeu_find_destination($urlname);
      
      $ret = str_replace("href=\\\"" . $urlname . "\\\"", "href=\\\"" . $real . "\\\"", $ret); 

   }
   return $ret;
} 

function wpeu_canonify_urls_in_post($data, $postarr) {
	$data['post_content'] = wpeu_canonify_urls($data['post_content']);
	return $data;
}

add_filter('wp_insert_post_data', 'wpeu_canonify_urls_in_post',20,2);
?>
